package org.gcube.dataanalysis.dataminer.poolmanager.util;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileWriter;
import java.io.InputStreamReader;
***REMOVED***
import java.util.ArrayList;
import java.util.Arrays;
import java.util.LinkedList;
***REMOVED***
import java.util.Properties;

import org.gcube.dataanalysis.dataminer.poolmanager.clients.configuration.Configuration;
***REMOVED***
import org.gcube.dataanalysis.dataminer.poolmanager.util.exception.AlgorithmException;
import org.gcube.dataanalysis.dataminer.poolmanager.util.exception.GenericException;
import org.gcube.dataanalysis.dataminer.poolmanager.util.exception.SVNCommitException;
***REMOVED***
***REMOVED***
***REMOVED***

import com.jcraft.jsch.Channel;
import com.jcraft.jsch.ChannelSftp;
import com.jcraft.jsch.JSch;
import com.jcraft.jsch.JSchException;
import com.jcraft.jsch.Session;
import com.jcraft.jsch.SftpException;

public abstract class CheckMethod ***REMOVED***
	
	private Logger logger;
	private Configuration configuration;
	
	private final String 	KNOWN_HOSTS= "~/.ssh/known_hosts",
							PRIVATE_KEY = "~/.ssh/id_rsa",
							SSH_USER = "root",
							SFTP_PROTOCOL = "sftp",
							TEMP_DIRECTORY = "tmp";
	private final Properties sshConfig;
	
	public CheckMethod(Configuration configuration) 
	***REMOVED***
		this.logger = LoggerFactory.getLogger(CheckMethod.class);
		this.configuration = configuration;
		sshConfig = new java.util.Properties();
		sshConfig.put("StrictHostKeyChecking", "no");
***REMOVED***
	
	public void checkMethod(String machine, String token) throws AlgorithmException ***REMOVED***
		try ***REMOVED***
			this.logger.debug("Checking method for machine "+machine);
			this.logger.debug("By using tocken "+token);
			this.logger.debug("Machine: " + machine);
***REMOVED***			String getCapabilitesRequest = new String();
***REMOVED***			String getCapabilitesResponse = new String();
			this.logger.debug("   Token: " + token);
			String request = "http:***REMOVED***" + machine
					+ "/wps/WebProcessingService?Request=GetCapabilities&Service=WPS&gcube-token=" + token;
			String response = machine + "___" + token + ".xml";
***REMOVED***			getCapabilitesRequest = request;
***REMOVED***			getCapabilitesResponse = response;
			String baseDescriptionRequest = "http:***REMOVED***" + machine
					+ "/wps/WebProcessingService?Request=DescribeProcess&Service=WPS&Version=1.0.0" + "&gcube-token="
					+ token + "&Identifier=";
			URL requestURL = new URL(request);
			this.logger.debug("Request url "+requestURL.toString());
			BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(requestURL.openStream()));
			FileWriter fileWriter = new FileWriter(response);
			String line;
			boolean flag = true;
			this.logger.debug("Writing file");
			while (flag && (line = bufferedReader.readLine()) != null) ***REMOVED***
				this.logger.debug(line);
				fileWriter.write(line);
				fileWriter.write(System.lineSeparator());
				
				if (line.contains("ows:Identifier")) 
				***REMOVED***
					this.logger.debug("Identifier found");
					String operatorName = line.substring(line.indexOf(">") + 1);
					operatorName = operatorName.substring(0, operatorName.indexOf("<"));
					this.logger.debug("Operator "+operatorName);
					URL innerRequestURL = new URL(baseDescriptionRequest + operatorName);
					BufferedReader innerBufferedReader = new BufferedReader(
							new InputStreamReader(innerRequestURL.openStream()));
					String innerLine = innerBufferedReader.readLine();
					this.logger.debug("Inner line "+innerLine);
					boolean innerFlag = true;
					while (innerFlag && (innerLine = innerBufferedReader.readLine()) != null) 
					***REMOVED***
						if (innerLine.contains("ows:Abstract")) 
						***REMOVED***
							this.logger.debug("Abstract found");
							String operatorDescription = innerLine.substring(innerLine.indexOf(">") + 1);
							operatorDescription = operatorDescription.substring(0, operatorDescription.indexOf("<"));
							this.logger.debug("Operator descriptor "+operatorDescription);
							this.logger.debug("         " + operatorDescription);
							innerFlag = false;
					***REMOVED*** else if (innerLine.contains("ows:ExceptionText")) 
						***REMOVED***
							this.logger.debug("Exception found");
							this.logger.debug("         " + "error retrieving operator description");
							innerFlag = false;
							flag = false;
					***REMOVED*** else
						***REMOVED***
							innerLine = innerBufferedReader.readLine();
							this.logger.debug("Inner line completed "+innerLine);
					***REMOVED***
				***REMOVED***
			***REMOVED***
		***REMOVED***
			
			this.logger.debug("Operation successful");
			fileWriter.close();


	***REMOVED*** catch (Exception e) ***REMOVED***
			
			throw new AlgorithmException("Error "+e.getMessage(),e);
			
	***REMOVED***
***REMOVED***
	
	

	public void copyAlgorithms(Algorithm algo/*, String env*/) throws SVNCommitException, GenericException, AlgorithmException
	***REMOVED***

		this.logger.debug("Looking if algo "+algo.getName()+ " exists");
		File file = new File(this.configuration.getGhostAlgoDirectory()+"/"+algo.getName()+".jar");
		File file2 = new File(this.configuration.getGhostAlgoDirectory()+"/"+algo.getName()+"_interface.jar");
		this.logger.debug("Looking for files "+file.getPath()+ " "+file.getPath());
		boolean fileExists = false;
		
		try
		***REMOVED***
			fileExists = (this.doesExist(file.getPath()/*,env*/)) && (this.doesExist(file2.getPath()/*,env*/));
			
	***REMOVED*** catch (Exception e)
		***REMOVED***
			throw new GenericException(e);
	***REMOVED***
		
		
		if (fileExists)
		***REMOVED***
			
			try
			***REMOVED***
				this.logger.debug("Files found");
				this.copyFromDmToSVN(file/*,env*/);
				this.copyFromDmToSVN(file2/*,env*/);
				this.logger.debug("Files have been copied to SVN");
		***REMOVED*** catch (Exception e)
			***REMOVED***
				throw new GenericException(e);
		***REMOVED***

	***REMOVED***
		else 
		***REMOVED***
			this.logger.debug("Files not found");
			this.logger.debug("Algorithm "+algo.getName()+".jar"+ " and "+algo.getName()+"_interface.jar files are not present at the expected path");
			throw new AlgorithmException("Algorithm "+algo.getName()+".jar"+ " and "+algo.getName()+"_interface.jar files are not present at the expected path");
	***REMOVED***
		
***REMOVED***


	
	public void deleteFiles(Algorithm a/*,String env*/) throws GenericException
	***REMOVED***
		try
		***REMOVED***
			Session session = generateSession();
			this.logger.debug("checking existing in env: " + this.configuration.getHost());
			
			File file = new File(this.configuration.getGhostAlgoDirectory()+"/"+a.getName()+".jar");
			File file2 = new File(this.configuration.getGhostAlgoDirectory()+"/"+a.getName()+"_interface.jar");
			
			
			this.logger.debug("First file is located to: "+file.getPath());
			this.logger.debug("Second file is located to: "+file2.getPath());
			
			
			this.logger.debug("session created.");
			session.setConfig(this.sshConfig);
			session.connect();

			Channel channel = session.openChannel(SFTP_PROTOCOL);
			channel.connect();
			this.logger.debug("shell channel connected....");

			ChannelSftp c = (ChannelSftp) channel;

			if(doesExist(file.getPath()/*,env*/)&&(doesExist(file2.getPath()/*,env*/)))***REMOVED***
				
				c.rm(file.getPath());
				c.rm(file2.getPath());
				this.logger.debug("Both the files have been deleted");
		***REMOVED***
			else this.logger.debug("Files not found");
		 	channel.disconnect();
			c.disconnect();
			session.disconnect();
	***REMOVED*** catch (Exception e)
		***REMOVED***
			throw new GenericException(e);
	***REMOVED***
		


***REMOVED***
	
	


	public boolean doesExist(String path/*, String env*/) throws Exception ***REMOVED***

		Session session = generateSession();
		boolean success = false;
		session.connect();
		Channel channel = session.openChannel(SFTP_PROTOCOL);
		channel.connect();
		this.logger.debug("shell channel connected....");
		ChannelSftp c = (ChannelSftp) channel;
		this.logger.debug(path);

		try ***REMOVED***
			c.lstat(path);
			success = true;
	***REMOVED*** catch (SftpException e) ***REMOVED***
			if (e.id == ChannelSftp.SSH_FX_NO_SUCH_FILE) ***REMOVED***
				***REMOVED*** file doesn't exist
				success = false;
		***REMOVED***
			***REMOVED***success = true; ***REMOVED*** something else went wrong
	***REMOVED***
		channel.disconnect();
		c.disconnect();
		session.disconnect();
		this.logger.debug("Operation result "+success);
		return success;

***REMOVED***

	
	protected abstract void copyFromDmToSVN(File a) throws SVNCommitException, Exception;

	
	protected void copyFromDmToSVN(File algorithmsFile/*,String env*/,SVNUpdater svnUpdater) throws SVNException, SVNCommitException, JSchException, SftpException ***REMOVED***

		this.logger.debug("Copying algorithm file from Data Miner to SVN");
		String fileName = algorithmsFile.getName();
		this.logger.debug("File name "+fileName);
		Session session = generateSession();
		session.connect();
		Channel channel = session.openChannel(SFTP_PROTOCOL);
		channel.connect();
		ChannelSftp sftp = (ChannelSftp) channel;
		sftp.cd(this.configuration.getGhostAlgoDirectory());
		String remoteFile = new StringBuilder(this.configuration.getGhostAlgoDirectory()).append(File.separator).append(fileName).toString();
		this.logger.debug("Remote file "+remoteFile);
		String localFile = new StringBuilder(File.separator).append(TEMP_DIRECTORY).append(File.separator).append(fileName).toString();
		this.logger.debug("Local file "+localFile);
		sftp.get(remoteFile,localFile);
		channel.disconnect();
		session.disconnect();
	    File f = new File(localFile);
		svnUpdater.updateAlgorithmFiles(f);	
		f.delete();
***REMOVED***
 
	private Session generateSession () throws JSchException
	***REMOVED***
		JSch jsch = new JSch();
		jsch.setKnownHosts(KNOWN_HOSTS);
		jsch.addIdentity(PRIVATE_KEY);
		this.logger.debug("Private Key Added.");
		Session session = jsch.getSession(SSH_USER, this.configuration.getHost());
		this.logger.debug("session created.");
		session.setConfig(this.sshConfig);
		return session;
***REMOVED***
 

    
	public static List<String> getFiles(String a)***REMOVED***

		String[] array = a.split(",");
		ArrayList<String> list = new ArrayList<>(Arrays.asList(array));
		List<String> ls = new LinkedList<String>();
		
        for (String s: list)***REMOVED***
        	ls.add(s.trim());
        ***REMOVED***
      
     	return ls;	
***REMOVED*** 
	
	

***REMOVED***
